/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.ProdukDao;
import com.portofolio.dto.ProdukDto;
import com.portofolio.entity.Produk;
import com.portofolio.entity.vo.ProdukId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class ProdukService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private ProdukDao produkDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(ProdukDto produkDto) {
		result.clear();
		ProdukId id = new ProdukId();
		Integer kdProduk =getIdTerahir(Produk.class.getSimpleName());
		id.setKdProduk(kdProduk);
		id.setKdProfile(getKdProfile());
		Produk produk = CommonUtil.findOne(produkDao, id);
		if (CommonUtil.isNullOrEmpty(produk)) {
			produk = new Produk();
			BeanUtils.copyProperties(produkDto, produk);
			produk.setNoRec(generateUuid32());
			produk.setVersion(1);
			produk.setId(id);
			produk = produkDao.save(produk);
			result.put("produk", produk);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("produk.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(ProdukDto produkDto, Integer kdProduk, Integer version) {
		result.clear();
		ProdukId id = new ProdukId();
		id.setKdProduk(kdProduk);
		id.setKdProfile(getKdProfile());
		Produk produk = CommonUtil.findOne(produkDao, id);
		if (CommonUtil.isNotNullOrEmpty(produk)) {
			if (version < produk.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(produkDto, produk);
			produk.setVersion(version);
			produk = produkDao.save(produk);
			result.put("produk", produk);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaProduk,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaProduk)) {
			pageRes = produkDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = produkDao.findAllList(getKdProfile(), namaProduk, statusEnabled, pageReq);
		}
		result.put("produk", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdProduk(Integer kdProduk) {
		result.clear();
		result.put("produk", produkDao.findByKdProduk(getKdProfile(), kdProduk, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdProduk, Integer version) {
		result.clear();
		ProdukId id = new ProdukId();
		id.setKdProduk(kdProduk);
		id.setKdProfile(getKdProfile());
		Produk produk = CommonUtil.findOne(produkDao, id);
		if (CommonUtil.isNotNullOrEmpty(produk)) {
			if (version < produk.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			produk.setStatusEnabled(false);
			produk.setVersion(version);
			produk = produkDao.save(produk);
			result.put("produk", produk);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
